// **********************************************************************
//
// source:
//
// type:      source code
//
// created:   15. Aug 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Class to initialize the BEE library
//
// changes:
// 15 Mai 2001 (TG) creation
//
// **********************************************************************

#include <iostream>

#include "clue/PkgIni.hh"
#include "BEEIni.hh"

#ifdef NAMESPACE
namespace CLUE {
#endif

// global CLUE symbol
#include "../CVStag.BEE"
const PkgIni BEESteer(xcvsMODULE_BEE, xcvsVERSION_BEE, xcvsDAYTIME_BEE);

// global ARTE symbol
#include "../arte/CVStag.arte"
const PkgIni ARTESteer(xcvsMODULE_arte, xcvsVERSION_arte, xcvsDAYTIME_arte);

// global CERN symbol
#include "../cern/CVStag.Cern"
const PkgIni CERNSteer(xcvsMODULE_Cern, xcvsVERSION_Cern, xcvsDAYTIME_Cern);

// global doc symbol
#include "../doc/CVStag.doc"
const PkgIni DocSteer(xcvsMODULE_doc, xcvsVERSION_doc, xcvsDAYTIME_doc);

// global gcombiner symbol
#include "../gcombiner/CVStag.gcombiner"
const PkgIni GCombinerSteer(xcvsMODULE_gcombiner, xcvsVERSION_gcombiner, xcvsDAYTIME_gcombiner);

// global grelation symbol
#include "../grelation/CVStag.grelation"
const PkgIni GRelationSteer(xcvsMODULE_grelation, xcvsVERSION_grelation, xcvsDAYTIME_grelation);

// global interface symbol
#include "../interfaces/CVStag.interfaces"
const PkgIni InterfacesSteer(xcvsMODULE_interfaces, xcvsVERSION_interfaces, xcvsDAYTIME_interfaces);

// global smatrix symbol
#include "../smatrix/CVStag.smatrix"
const PkgIni SMatrixSteer(xcvsMODULE_smatrix, xcvsVERSION_smatrix, xcvsDAYTIME_smatrix);
#ifdef NAMESPACE
} // namespace CLUE#endif
#endif
