
/* ********************************************************************/
//
// $Source: /afs/desy.de/user/h/hbxxcus/BEE/Cern/include/higz.hh,v $
// $Revision: 1.1.1.3 $
// $Author: cluerep $
// $Date: 2001/01/09 15:08:58 $
//
// Created: 06-27-97,   C. Borgmeier
//
/* ********************************************************************/


#include <CLHEP/Utilities/fortran.h>

#ifndef _HIGZ_HH_
#define _HIGZ_HH_

// the needed fortran routines
extern "C" {
  void FORTRAN_ROUTINE(hbfinit)( void );
  void FORTRAN_ROUTINE(iginit)( const int &nwhigz );
  void FORTRAN_ROUTINE(igend) ( void );
  void FORTRAN_ROUTINE(igmeta)( const int &lun, const int &kwtype );
  void FORTRAN_ROUTINE(igsse) ( const int &ierrf, const int &kwtype );
  void FORTRAN_ROUTINE(iclrwk)( const int &kwkid, const int &kofl );
  void FORTRAN_ROUTINE(igrng) ( const float &xsize, const float &ysize );
  void FORTRAN_ROUTINE(iswn)  ( const int &nt,
				const float &xmin, const float &xmax,
				const float &ymin, const float &ymax );
  void FORTRAN_ROUTINE(isvp)  ( const int &nt,
				const float &xmin, const float &xmax,
				const float &ymin, const float &ymax );
  void FORTRAN_ROUTINE(iselnt)( const int &nt );
  void FORTRAN_ROUTINE(iuwk)  ( const int &kwkid, const int &irflg );
  void FORTRAN_ROUTINE(ipm)   ( const int &n,
				const float &x, const float &y );
  void FORTRAN_ROUTINE(ipl)   ( const int &n,
				const float x[], const float y[] );
  void FORTRAN_ROUTINE(ispmci)( const int &iColI );
  void FORTRAN_ROUTINE(isplci)( const int &iColI );
  void FORTRAN_ROUTINE(isln)  ( const int &ltype );
  void FORTRAN_ROUTINE(ismk)  ( const int &mtype );
  void FORTRAN_ROUTINE(ismksc)( const float &ssfm );
  void FORTRAN_ROUTINE(iscr)  ( const int& kwkid, const int& ici,
				const float& cr,
				const float& cg, const float& cb );
  void FORTRAN_ROUTINE(igaxis)( const float &x0, const float &x1,
				const float &y0, const float &y1,
				const float &wmin, const float &wmax,
				const int &ndiv, const char* chopt, int len );
  void FORTRAN_ROUTINE(igloc2)( const int &kwkid, int &nt, float &x1,
				float &y1,
				float &x2, float &y2, int &istat,
				const char* chopt, int lenChopt);
  void FORTRAN_ROUTINE(ighist)( const int &n,
				const float x[], const float y[]);
  void FORTRAN_ROUTINE(igtabl)( const int& nx, const int& ny,
				const float v[], // []?
                                const int& npar, const float par[],
                                const char* chopt, int len );
  void FORTRAN_ROUTINE(igset) ( const char chname[4], const float &val );
  void FORTRAN_ROUTINE(igtext)( const float& x, const float& y,
				const char* chars, const float& size,
				const float& angle, const char* chopt,
				int charslen, int choptlen );
  void FORTRAN_ROUTINE(itx)   ( const float& x, const float& y,
				const char* chars, int charslen );
  void FORTRAN_ROUTINE(izpict)( char* str1, char* str2, int l1, int l2 );
  void FORTRAN_ROUTINE(igzset)( char* str, int len );

  // HPLOT

  void FORTRAN_ROUTINE(hplint)( const int& iwtyp );
  void FORTRAN_ROUTINE(hplend)();
  void FORTRAN_ROUTINE(hplcap)( const int& ifile );
  void FORTRAN_ROUTINE(hplfra)( const float &xmin, const float &xmax,
				const float &ymin, const float &ymax,
				const char* chopt, int len );
  void FORTRAN_ROUTINE(hplnul)();
  void FORTRAN_ROUTINE(hplopt)( const char chname[4], const int &n, int len );
  void FORTRAN_ROUTINE(hplset)( const char* chname, const float& var,
				int len );
  void FORTRAN_ROUTINE(hpltit)( const char* chtit, int len );
  void FORTRAN_ROUTINE(hpllgd)( const char* chxtit, const char* chytit,
				const char* chztit, const int& ialgn,
				const char* chopt,
				int xtitlen, int ytitlen, int ztitlen,
				int optlen );
  void FORTRAN_ROUTINE(hplax) ( const char* chxtit, const char* chytit,
				int xtitlen, int ytitlen );
}


#include <string.h>

inline void igtext( float x, float y, const char* chars,
		    float size, float angle, const char* chopt )
{
  FORTRAN_ROUTINE(igtext)( x, y, chars, size, angle, chopt,
			   strlen( chars ), strlen( chopt ) );
}


inline void itx( float x, float y, const char* chars )
{
  FORTRAN_ROUTINE(itx)( x, y, chars, strlen( chars ) );
}


inline void igset( const char chname[4], float val )
{
  FORTRAN_ROUTINE(igset)( chname, val );
}


inline void igaxis( float x0, float x1, float y0, float y1,
		    float wmin, float wmax,
		    int ndiv, const char* chopt )
{
  FORTRAN_ROUTINE(igaxis)( x0, x1, y0, y1, wmin, wmax, ndiv, chopt,
			   strlen( chopt ) );
}


inline void iselnt( int nt )
{
  FORTRAN_ROUTINE(iselnt)( nt );
}


inline void izpict( char* str1, char* str2 )
{
  FORTRAN_ROUTINE(izpict)( str1, str2, strlen( str1 ), strlen( str2 ) );
}


inline void igzset( char* str )
{
  FORTRAN_ROUTINE(igzset)( str, strlen( str ) );
}


inline void hplfra( float x1, float x2, float y1, float y2, const char* chopt )
{
  FORTRAN_ROUTINE(hplfra)( x1, x2, y1, y2, chopt, strlen( chopt ) );
}


inline void hplnul()
{
  FORTRAN_ROUTINE(hplnul)();
}


inline void hplopt( const char chopt[4] )
{
  FORTRAN_ROUTINE(hplopt)( chopt, 1, 4 );
} 


inline void hplset( const char chname[4], float var )
{
  FORTRAN_ROUTINE(hplset)( chname, var, 4 );
}


inline void hpltit( const char* chtit )
{
  FORTRAN_ROUTINE(hpltit)( chtit, strlen( chtit ) );
} 


inline void hpllgd( const char* chxtit,
		    const char* chytit,
		    const char* chztit = "",
		    int ialgn = 3,
		    const char* chopt = "")
{
  FORTRAN_ROUTINE(hpllgd)( chxtit, chytit, chztit, ialgn, chopt,
			   strlen( chxtit ),
			   strlen( chytit ),
			   strlen( chztit ),
			   strlen( chopt ) );
}


inline void hplax( const char* chxtit, const char* chytit )
{
  FORTRAN_ROUTINE(hplax)( chxtit, chytit,
			  strlen( chxtit ), strlen( chytit ) );
}


inline void iuwk( int id = 0, int irflag = 1 )
{
  FORTRAN_ROUTINE(iuwk)( id, irflag );
}

#endif
