// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   16. Aug 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Class to initialize a BEE project
//
// changes:
// 16 Aug 2001 (TG) creation
//
// ********************************************************************
#include <iostream>
#include <string>
#include "clue/PkgIni.hh"

//==============================================================================
// Constructors
//==============================================================================
PkgIni::PkgIni() :
  Name(""),
  Version(""),
  Date(""),
  Debug(false)
{}

PkgIni::PkgIni( const char* nam, const char* vers, const char* dat ): 
  Name(nam),
  Version(vers),
  Date(dat),
  Debug(false) {

  print(cout);
}


PkgIni::~PkgIni() {}

//==============================================================================
// print
//==============================================================================
std::ostream& PkgIni::print(std::ostream& os) const {
  string nam(Name);
  string ver(Version);
  string dat(Date);

  return os << nam << string(12-nam.length(),' ')
	    << ver << string(10-ver.length(),' ') << "from "
	    << dat << string(30-dat.length(),' ') << "loaded"
	    << endl;
}
