#ifndef CLONES_TABLE_SPEC_HH
#define CLONES_TABLE_SPEC_HH
// *****************************************************************************
//
// source:
//
// type:      source code
//
// created:   ???
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: specialize Arte-Table Templates for usage in ROOT
//
// changes:
// ???         created by C. Borgmeier
// 20 Nov 1999 (TG) added using namespace CLUE statement
// 14 Nov 2001 (TG) renamed ClonesTable.icc to ArteSpecialize.hh
// 16 Dec 2001 (TG) removed #include "StreamObject.hh"
//
// *****************************************************************************

// this code cannot be parsed by CINT
// it's ok to just get it into the
// dictionary
#ifndef __CINT__
#include "arte/arte.hh"            // needed for RtEvent.hh
#include "clue/RtEvent.hh"         // specialize getBase()
#include "gate/ArteSpecialize.hh"  // adopt ARTE interface
#include "clue/cluefwd.hh"

#undef getLink

#ifdef NAMESPACE
ArtePointerSpecialize(CLUE::VDS_Track)
ArtePointerSpecialize(CLUE::OTR_SpacePoint)
ArtePointerSpecialize(CLUE::RICH_Track)
ArtePointerSpecialize(CLUE::MuonTrack)
ArtePointerSpecialize(CLUE::RecoTrack)
ArtePointerSpecialize(CLUE::RecoVertex)
ArtePointerSpecialize(CLUE::TrackClones)
ArtePointerSpecialize(CLUE::MC_Track)
ArtePointerSpecialize(CLUE::MC_Vertex)
ArtePointerSpecialize(CLUE::Topp)
ArtePointerSpecialize(CLUE::Wire)
ArtePointerSpecialize(CLUE::EcalHit)
#else   // NAMESPACE
ArtePointerSpecialize(VDS_Track)
ArtePointerSpecialize(OTR_SpacePoint)
ArtePointerSpecialize(RICH_Track)
ArtePointerSpecialize(MuonTrack)
ArtePointerSpecialize(RecoTrack)
ArtePointerSpecialize(RecoVertex)
ArtePointerSpecialize(TrackClones)
ArtePointerSpecialize(MC_Track)
ArtePointerSpecialize(MC_Vertex)
ArtePointerSpecialize(Topp)
ArtePointerSpecialize(Wire)
ArtePointerSpecialize(EcalHit)
#endif

#endif  // ifndef __CINT__
#endif
