#ifndef STREAMOBJECT_HH
#define STREAMOBJECT_HH
// *****************************************************************************
//
// source:
//
// type:      source code
//
// created:   20. Jul 1997
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: The streamable part of an RtEvent
//
// changes:
// 20 Jul 1997 created by C. Borgmeier
// 20 Nov 2000 (TG) added namespace CLUE
// 14 Aug 2001 (TG) incremented Version number
// 05 Sep 2001 (TG) incremented class version
//
// *****************************************************************************
#ifdef USE_ROOT
#include <TObject.h>

#ifdef NAMESPACE
namespace CLUE {
#endif
  class RtEvent;

  /** Helper class to write and read CLUE events from/to ROOT files.
      @memo write/read ROOT files
      @author C. Borgmeier, T. Glebe
  */
  //==============================================================================
  // StreamObject
  //==============================================================================
  class StreamObject: public TObject {
  public:
    ///
    StreamObject();
    ///
    StreamObject( RtEvent* );

  private:
    static RtEvent* event;
    
    ClassDef(StreamObject,3)
 }; // end of class StreamObject
#endif // USE_ROOT

#ifdef NAMESPACE
} // namespace CLUE
#endif
#endif
