j// **********************************************************************
//
// source:
//
// type:      source code
//
// created:   16. Sep 1998
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Class describing a member function and a search pattern
//
// changes:
// 16 Sep 1998 creation by C. Borgmeier
// 03 Nov 2000 (TG) code polishing
// 20 Nov 2000 (TG) added namespace CLUE
// 27 Dec 2000 (TG) end() optimization
// 24 Jan 2001 (TG) make operators inline, removed select() functions,
//                  removed obsolete include files
//
// **********************************************************************
#include <iostream>

//  #include "gate/ObjArray.hh"
//  #include "gate/ClonesArray.hh"
//#include "clue/Property.hh"
//#include "clue/cluearte.hh"         // needed for RecoTrack
// #include "geometry/Point3D.hh"  // needed for RecoSegment.hh
//#include "clue/RecoTrack.hh"
//  #include "gate/ObjArray.hh"     // for Pattern.hh
//  #include "clue/SmartPointer.hh" // for Pattern.hh
//  #include "clue/Pattern.hh"      // for PatternMatch.hh
//  #include "clue/PatternMatch.hh"

#ifdef NAMESPACE
namespace CLUE {
#endif

#ifdef USE_ROOT
  ClMyImpT2(ClProperty,C,T)
  ClMyImpT3(ClExpression,C,T,X)
  ClMyImpT2(ClMember,C,T)
  ClMyImpT4(ClMemberTwoPar,C,T,P1,P2)
  ClMyImpT2(ClConstant,C,T)
#endif
  
#ifdef XXX
  template class ClProperty<RecoTrack,int>;
  template class ClProperty<RecoTrack,float>;
  template class ClExpression<RecoTrack,int,int>;
  template class ClExpression<RecoTrack,float,int>;
  template class ClExpression<RecoTrack,float,float>;
  template class ClMember<RecoTrack,float>;
  template class ClMember<RecoTrack,int>;
  template class ClMemberTwoPar<RecoTrack,float,int,int>;
  template class ClConstant<RecoTrack,float>;
  template class ClConstant<RecoTrack,int>;
  
  template class ClProperty<RecoSegment,int>;
  template class ClProperty<RecoSegment,float>;
  template class ClExpression<RecoSegment,int,int>;
  template class ClExpression<RecoSegment,float,int>;
  template class ClExpression<RecoSegment,float,float>;
  template class ClMember<RecoSegment,float>;
  template class ClMember<RecoSegment,int>;
  template class ClMemberTwoPar<RecoSegment,float,int,int>;
  template class ClConstant<RecoSegment,float>;
  template class ClConstant<RecoSegment,int>;
#endif

  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T>
    T ClProperty<C,T>::operator()( const C& ) const { return 0; }


  //==============================================================================
  // operator ()
  //==============================================================================
//    template <class C, class T>
//      T ClProperty<C,T>::operator()( const TrackBase& ) const { return 0; }


  //==============================================================================
  // propertyClone
  //==============================================================================
  template <class C, class T>
    ClProperty<C,T>* ClProperty<C,T>::propertyClone() const {
    std::cerr << "Property.C: warning: cannot clone ClProperty, *this=";
    print( std::cerr );
    return 0;
  }


  //==============================================================================
  // print
  //==============================================================================
  template <class C, class T>
    std::ostream& ClProperty<C,T>::print( std::ostream& os ) const {
    return os << "(ClProperty)";
  }


  // template <class C, class T>
  // std::ostream& operator<<( std::ostream& os, const ClProperty<C,T>& prop )
  // {
  //   prop.print();
  // }


  //
  // less
  //

  //==============================================================================
  // lessfunc
  //==============================================================================
//    template <class T>
//      static int lessfunc(const T& lhs, const T& rhs ) { return lhs < rhs; }


  //==============================================================================
  // operator <
  //==============================================================================
  //  template <class C, class T>
  //  ClExpression<C,T,int> ClProperty<C,T>::operator<( const ClProperty<C,T>& rhs )
  //    const {
  //    return ClExpression<C,T,int>( *this, rhs, &lessfunc );
  //  }


  //==============================================================================
  // operator <
  //==============================================================================
  //  template <class C, class T>
  //  ClExpression<C,T,int> ClProperty<C,T>::operator<( T rhs ) const {
  //    return *this < ClConstant<C,T>( rhs );
  //  }


  //
  // more
  //

  //==============================================================================
  // morefunc
  //==============================================================================
//    template <class T>
//      static int morefunc( const T& lhs, const T& rhs ) { return lhs > rhs; }
  

  //==============================================================================
  // operator >
  //==============================================================================
  //  template <class C, class T>
  //  ClExpression<C,T,int> ClProperty<C,T>::operator>( const ClProperty<C,T>& rhs )
  //    const {
  //    return ClExpression<C,T,int>( *this, rhs, &morefunc );
  //  }
  

  //==============================================================================
  // operator >
  //==============================================================================
  //  template <class C, class T>
  //  ClExpression<C,T,int> ClProperty<C,T>::operator>( T rhs ) const {
  //    return operator>( ClConstant<C,T>( rhs ) );
  //  }


  //
  // equals
  //

  //==============================================================================
  // equalsfunc
  //==============================================================================
//    template <class T>
//      static int equalsfunc( const T& lhs, const T& rhs ) { return lhs == rhs; }
  

  //==============================================================================
  // operator ==
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,int> ClProperty<C,T>::operator==( const ClProperty<C,T>& rhs )
  //      const {
  //        return ClExpression<C,T,int>( *this, rhs, &equalsfunc );
  //      }


  //==============================================================================
  // operator ==
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,int> ClProperty<C,T>::operator==( T rhs ) const {
  //        return *this == ClConstant<C,T>( rhs );
  //      }


  //
  // not equal
  //

  //==============================================================================
  // notequalfunc
  //==============================================================================
//    template <class T>
//      static int notequalfunc( const T& lhs, const T& rhs ) { return lhs != rhs; }


  //==============================================================================
  // operator !=
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,int> ClProperty<C,T>::operator!=( const ClProperty<C,T>& rhs )
  //      const {
  //        return ClExpression<C,T,int>( *this, rhs, &notequalfunc );
  //      }


  //==============================================================================
  // operator !=
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,int> ClProperty<C,T>::operator!=( T rhs ) const {
  //        return operator!=( ClConstant<C,T>( rhs ) );
  //      }


  //
  // plus
  //

  //==============================================================================
  // plusfunc
  //==============================================================================
//    template <class T>
//      static T plusfunc( const T& lhs, const T& rhs ) { return lhs + rhs; }
  
  
  //==============================================================================
  // operator +
  //==============================================================================
//    template <class C, class T>
//      ClExpression<C,T,T> ClProperty<C,T>::operator+( const ClProperty<C,T>& rhs )
//      const {
//      return ClExpression<C,T,T>( *this, rhs, &plusfunc );
//    }


  //==============================================================================
  // operator +
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,T> ClProperty<C,T>::operator+( T rhs ) const {
  //      return *this + ClConstant<C,T>( rhs );
  //    }


  //
  // minus
  //

  //==============================================================================
  // minusfunc
  //==============================================================================
//    template <class T>
//      static T minusfunc( const T& lhs, const T& rhs ) { return lhs - rhs; }
  

  //==============================================================================
  // operator -
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,T> ClProperty<C,T>::operator-( const ClProperty<C,T>& rhs )
  //      const {
  //      return ClExpression<C,T,T>( *this, rhs, &minusfunc );
  //    }


  //==============================================================================
  // operator -
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,T> ClProperty<C,T>::operator-( T rhs ) const {
  //      return *this - ClConstant<C,T>( rhs );
  //    }


  //
  // times
  //

  //==============================================================================
  // timesfunc
  //==============================================================================
//    template <class T>
//      static T timesfunc( const T& lhs, const T& rhs ) { return lhs * rhs; }
  

  //==============================================================================
  // operator *
  //==============================================================================
//    template <class C, class T>
//      ClExpression<C,T,T> ClProperty<C,T>::operator*( const ClProperty<C,T>& rhs )
//      const {
//      return ClExpression<C,T,T>( *this, rhs, &timesfunc );
//    }


  //==============================================================================
  // operator *
  //==============================================================================
//    template <class C, class T>
//      ClExpression<C,T,T> ClProperty<C,T>::operator*( T rhs ) const {
//      return *this * ClConstant<C,T>( rhs );
//    }


  //
  // divide
  //

  //==============================================================================
  // dividefunc
  //==============================================================================
//    template <class T>
//      static T dividefunc( const T& lhs, const T& rhs ) { return lhs / rhs; }


  //==============================================================================
  // operator /
  //==============================================================================
//    template <class C, class T>
//      ClExpression<C,T,T> ClProperty<C,T>::operator/( const ClProperty<C,T>& rhs )
//      const {
//      return ClExpression<C,T,T>( *this, rhs, &dividefunc );
//    }


  //==============================================================================
  // operator /
  //==============================================================================
//    template <class C, class T>
//      ClExpression<C,T,T> ClProperty<C,T>::operator/( T rhs ) const {
//      return *this / ClConstant<C,T>( rhs );
//    }


  //
  // and
  //

  //==============================================================================
  // andfunc
  //==============================================================================
//    template <class T>
//      static int andfunc( const T& lhs, const T& rhs ) {
//      return static_cast<bool>(lhs) && static_cast<bool>(rhs);
//    }


  //==============================================================================
  // operator &
  //==============================================================================
//    template <class C, class T>
//      ClExpression<C,T,int> ClProperty<C,T>::operator&( const ClProperty<C,T>& rhs )
//      const {
//      return ClExpression<C,T,int>( *this, rhs, &andfunc );
//    }


  //
  // or
  //
  
  //==============================================================================
  // orfunc
  //==============================================================================
//    template <class T>
//      static int orfunc( const T& lhs, const T& rhs ) {
//      return static_cast<bool>(lhs) || static_cast<bool>(rhs);
//    }


  //==============================================================================
  // operator |
  //==============================================================================
  //    template <class C, class T>
  //      ClExpression<C,T,int> ClProperty<C,T>::operator|( const ClProperty<C,T>& rhs )
  //      const {
  //      return ClExpression<C,T,int>( *this, rhs, &orfunc );
  //    }


  //
  //
  //

  //==============================================================================
  // Constructors
  //==============================================================================
//    template <class C, class T>
//      ClProperty<C,T>::~ClProperty()
//      {
//        //cerr << "delete ClProperty" << this << endl;
//      }


  //==============================================================================
  // operator =
  //==============================================================================
  template <class C, class T>
    const ClProperty<C,T>& ClProperty<C,T>::operator=( const ClProperty<C,T>& rhs ) {
      if( this == &rhs ) return *this;
      std::cerr << "Property.C: warning: cannot assign ClProperty << *this=";
      print( std::cerr );
      std::cerr << "                                                 right=";
      //  const_cast<ClProperty<C,T>&>(rhs).Print();
      return *this;
    }
  

  //==============================================================================
  // Constructors
  //==============================================================================
  template <class C, class T, class X>
    ClExpression<C,T,X>::ClExpression()
    : lhs( 0 ), rhs( 0 ) {}


  template <class C, class T, class X>
    ClExpression<C,T,X>::ClExpression( const ClProperty<C,T>& l,
				       const ClProperty<C,T>& r,
				       X (*f)( const T&, const T& ) ) :
    lhs( l.propertyClone() ),
    rhs( r.propertyClone() ),
    func( f ) {
    //cerr << "new ClExpression" << this  << endl;  
  }


  template <class C, class T, class X>
    ClExpression<C,T,X>::~ClExpression()
    {
      //cerr << "delete ClExpression" << this  << endl;
      delete lhs;
      delete rhs;
    }


  //==============================================================================
  // operator =
  //==============================================================================
//    template <class C, class T, class X>
//      const ClExpression<C,T,X>&
//      ClExpression<C,T,X>::operator=( const ClExpression<C,T,X>& r ) {
//        // if( this == &rhs ) return *this; // cannot be used here
//        lhs = r.lhs->propertyClone();
//        rhs = r.rhs->propertyClone();
//        func = r.func;
//        return *this;
//      }


  //==============================================================================
  // propertyClone
  //==============================================================================
//    template <class C, class T, class X>
//      ClProperty<C,X>* ClExpression<C,T,X>::propertyClone() const {
//      return new ClExpression<C,T,X>( *lhs, *rhs, func );
//    }

  
  //==============================================================================
  // print
  //==============================================================================
  template <class C, class T, class X>
    std::ostream& ClExpression<C,T,X>::print( std::ostream& os ) const {
    os << '(';
    lhs->print( os );
    os << ',';
    rhs->print( os );
    os << ')';
    return os;
  }
  

  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T, class X>
    X ClExpression<C,T,X>::operator()( const C& part ) const {
    T l = (*lhs)(part);
    T r = (*rhs)(part);
    X val = func( l, r );
    return val;
  }

  
  //==============================================================================
  // operator ()
  //==============================================================================
//    template <class C, class T, class X>
//      X ClExpression<C,T,X>::operator()( const TrackBase& part ) const {
//      T l = (*lhs)(part);
//      T r = (*rhs)(part);
//      X val = func( l, r );
//      return val;
//    }


  //==============================================================================
  // Constructors
  //==============================================================================
  template <class C, class T>
    ClMember<C,T>::ClMember( T (C::*f)() const ) : func( f ) {
    //cerr << "new ClMember" << this  << endl;
  }
  

  template <class C, class T>
    ClMember<C,T>::~ClMember() {
    //cerr << "delete ClMember" << this  << endl;
  }


  //==============================================================================
  // propertyClone
  //==============================================================================
  template <class C, class T>
    ClProperty<C,T>* ClMember<C,T>::propertyClone() const {
    return new ClMember<C,T>( func );
  }


  //==============================================================================
  // print
  //==============================================================================
  template <class C, class T>
    std::ostream& ClMember<C,T>::print( std::ostream& os ) const {
    return os << "(ClMember)";
  }
  

  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T>
    T ClMember<C,T>::operator()( const C& part ) const {
    return (part.*func)();
  }


  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T>
    T ClMember<C,T>::operator()( const TrackBase& part ) const
    {
      cout << "------> ClMember: attention, disabled code! " << endl;
      return T();

#ifdef XXX
#ifdef USE_ROOT
      if( const_cast<TrackBase&>( part ).InheritsFrom( PatternMatch::Class() ) ) {
	const TrackBase* track
	  = reinterpret_cast<const PatternMatch&>( part ).track;
	if( track!=0 ) {
	  return (reinterpret_cast<const RecoTrack&>( *track ).*func)();
	} else return 0;
      } else {
#endif
	return (reinterpret_cast<const RecoTrack&>( part ).*func)();
#ifdef USE_ROOT
      }
#endif
#endif
    }


  //==============================================================================
  // Constructor
  //==============================================================================
  template <class C, class T, class P>
    ClMemberOnePar<C,T,P>::ClMemberOnePar( T (C::*f)( P ) const, P p ) : func( f ),
    par( p ) {}
  
  
  template <class C, class T, class P>
    ClMemberOnePar<C,T,P>::~ClMemberOnePar() {}

  
  //==============================================================================
  // propertyClone
  //==============================================================================
  template <class C, class T, class P>
    ClProperty<C,T>* ClMemberOnePar<C,T,P>::propertyClone() const {
    return new ClMemberOnePar<C,T,P>( func, par );
  }
  
  
  //==============================================================================
  // print
  //==============================================================================
  template <class C, class T, class P>
    std::ostream& ClMemberOnePar<C,T,P>::print( std::ostream& os ) const {
    return os << "(ClMemberOnePar: " << par << ")";
  }


  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T, class P>
    T ClMemberOnePar<C,T,P>::operator()( const C& part ) const {
    return (part.*func)( par );
  }


  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T, class P>
    T ClMemberOnePar<C,T,P>::operator()( const TrackBase& part ) const {
    cout << "---------> ClMemberOnePar: disabled code!" << endl;
    return T();
#ifdef XXX
#ifdef USE_ROOT
    if( const_cast<TrackBase&>( part ).InheritsFrom( PatternMatch::Class() ) ) {
      const TrackBase* track
	= reinterpret_cast<const PatternMatch&>( part ).track;
      if( track!=0 ) {
	return (reinterpret_cast<const RecoTrack&>( *track ).*func)( par );
      } else return 0;
    } else {
#endif
      return (reinterpret_cast<const RecoTrack&>( part ).*func)( par );
#ifdef USE_ROOT
    }
#endif
#endif
  }


  //==============================================================================
  // Constructors
  //==============================================================================
  template <class C, class T, class P1, class P2>
    ClMemberTwoPar<C,T,P1,P2>::ClMemberTwoPar( T (C::*f)( P1, P2 ) const,
					       P1 p1,
					       P2 p2 ) : func( f ),
    par1( p1 ),
    par2( p2 ) {}
  

  template <class C, class T, class P1, class P2>
    ClMemberTwoPar<C,T,P1,P2>::~ClMemberTwoPar() {}


  //==============================================================================
  // propertyClone
  //==============================================================================
  template <class C, class T, class P1, class P2>
    ClProperty<C,T>* ClMemberTwoPar<C,T,P1,P2>::propertyClone() const {
    return new ClMemberTwoPar<C,T,P1,P2>( func, par1, par2 );
  }

  
  //==============================================================================
  // print
  //==============================================================================
  template <class C, class T, class P1, class P2>
    std::ostream& ClMemberTwoPar<C,T,P1,P2>::print( std::ostream& os ) const {
    return os << "(ClMemberTwoPar: " << par1 << ',' << par2 << ")";
  }


  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T, class P1, class P2>
    T ClMemberTwoPar<C,T,P1,P2>::operator()( const C& part ) const {
    return (part.*func)( par1, par2 );
  }


  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T, class P1, class P2>
    T ClMemberTwoPar<C,T,P1,P2>::operator()( const TrackBase& part ) const {
    cout << "-------> ClMemberTwoPar: disabled code!" << endl;
    return T();
#ifdef XXX
#ifdef USE_ROOT
    if( const_cast<TrackBase&>( part ).InheritsFrom( PatternMatch::Class() ) ) {
      const TrackBase* track
	= reinterpret_cast<const PatternMatch&>( part ).track;
      if( track!=0 ) {
	return (reinterpret_cast<const RecoTrack&>( *track ).*func)( par1,
								     par2 );
      } else return 0;
    } else {
#endif
      return (reinterpret_cast<const RecoTrack&>( part ).*func)( par1, par2 );
#ifdef USE_ROOT
    }
#endif
#endif
  }


  //==============================================================================
  // Constructor
  //==============================================================================
  template <class C, class T>
    ClConstant<C,T>::ClConstant( T cons ) : constant( cons ) {
    //cerr << "new ClConstant:" << this << ',' << constant << endl;  
  }


  template <class C, class T>
    ClConstant<C,T>::~ClConstant() {
    //cerr << "delete ClConstant" << this << ',' << constant << endl;  
  }


  //==============================================================================
  // propertyClone
  //==============================================================================
  template <class C, class T>
    ClProperty<C,T>* ClConstant<C,T>::propertyClone() const {
    return new ClConstant<C,T>( constant );
  }


  //==============================================================================
  // print
  //==============================================================================
  template <class C, class T>
    std::ostream& ClConstant<C,T>::print( std::ostream& os ) const {
    return os << constant << ")";
  }


  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T>
    T ClConstant<C,T>::operator()( const C& ) const {
    return constant;
  }


  //==============================================================================
  // operator ()
  //==============================================================================
  template <class C, class T>
    T ClConstant<C,T>::operator()( const TrackBase& ) const {
    return constant;
  }


#ifdef NAMESPACE
} // namespace CLUE
#endif
