//**********************************************************************
//
// source:
//
// type:      source code
//
// created:   27. Jan 1997
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Class for handling reconstructed Tracks.
//
// changes:
// 21 Jan 1997 created by I. Siccama, C. Borgmeier
// 03 Nov 2000 (TG) removed #ifdef __CINT__, changed include files
// 20 Nov 2000 (TG) added namespace CLUE
// 12 Jan 2001 (TG) print() function changed
// 12 Jan 2001 (TG) removed LorentzVector dependency
//
//**********************************************************************
#include <iostream>

#include "clue/TrackBase.hh"

#ifdef NAMESPACE
namespace CLUE {
#endif

  //==============================================================================
  // Destructor
  //==============================================================================
  TrackBase::~TrackBase() {}


  //==============================================================================
  // print
  //==============================================================================
  std::ostream& TrackBase::print( std::ostream& os ) const {
    return os << "(TB)";
  }

  //==============================================================================
  // lock
  //==============================================================================
  // do nothing
  void TrackBase::lock() {}


  //==============================================================================
  // unlock
  //==============================================================================
  // do nothing
  void TrackBase::unlock() {}


  //==============================================================================
  // locked
  //==============================================================================
  // do nothing
  int TrackBase::locked( int ) const { return false; }
  

  //==============================================================================
  // mass
  //==============================================================================
  float TrackBase::mass() const { return 0; }


  //==============================================================================
  // getRecoTrack
  //==============================================================================
  const RecoTrack* TrackBase::getRecoTrack() const { return 0; }


#ifdef USE_ROOT
  ClassImp(TrackBase)
#endif

#ifdef NAMESPACE
} // namespace CLUE
#endif
