#ifndef __K0Analysis_HH
#define __K0Analysis_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Fre Sep 28 10:39:20 MEST 2001
//
// author:    glebe
//
// Description: 
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// K0Analysis
//==============================================================================
class K0Analysis : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  K0Analysis(RtEvent* evt);
  ///
  virtual ~K0Analysis() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "K0Analysis"; }

private:
  RtEvent* event;

  // --- pattern --------------------------------------
  TrackPattern Piplus;
  TrackPattern Piminus;

  // K0s -> pi+pi-
  TwoProngDecay kshort;

  TNtuple* Kshort;

}; // end of K0Analysis
#endif

