#ifndef __MCAna3_HH
#define __MCAna3_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Die Aug 14 10:33:50 MEST 2001
//
// author:    glebe
//
// Description: 
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// MCAna3
//==============================================================================
class MCAna3 : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  MCAna3(RtEvent* evt);
  ///
  virtual ~MCAna3() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "MCAna3"; }

private:
  RtEvent* event;

  TrackPattern PiPlus;
  TrackPattern KMinus;

  // D_0 -> pi+ K-
  TwoProngDecay Dzero;

  TH1F* PtMC;
  TH1F* PtRECO;

}; // end of MCAna3
#endif

