#ifndef __v0Analysis_HH
#define __v0Analysis_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Die Okt  2 12:18:59 MEST 2001
//
// author:    glebe
//
// Description: 
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// v0Analysis
//==============================================================================
class v0Analysis : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  v0Analysis(RtEvent* evt);
  ///
  virtual ~v0Analysis() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "v0Analysis"; }

private:
  RtEvent* event;

  // -- event statistics
  unsigned int nacc;
  unsigned int nrej;
  unsigned int pidyes;
  unsigned int pidno;

  // --- pattern --------------------------------------
  TrackPattern Piplus;
  TrackPattern Piminus;
  TrackPattern Kplus;
  TrackPattern Kminus;
  TrackPattern Muplus;
  TrackPattern Muminus;

  // K0s -> pi+pi-
  TwoProngDecay Kshort;
  // phi -> K+K-
  TwoProngDecay Phi;
  // J/Psi -> mu+mu-
  TwoProngDecay JPsi;
  // B0 -> pi+pi-
  TwoProngDecay B0;
  // B0 -> K+pi-
  TwoProngDecay B0b;
  // B0bar -> K-pi+
  TwoProngDecay B0bar;

  TNtuple* kshort;
  TH2F*    ptxf;
  TH1F*    mom;

  TNtuple* Nphi;
  TNtuple* Njpsi;
  TNtuple* NB;
  TNtuple* NBkp;
  TH1F*    tri;
}; // end of v0Analysis
#endif

