BEGIN {
  print "#ifdef USE_ROOT";
  print "#include <Gate/ObjArray.hh>\n";
  print "#include <Gate/ClonesArray.h>\n";
  print "#include <Clue/Pattern.h>";
  print "#include <Clue/Wire.hh>";
  print "#include <Clue/CustomTrack.hh>";
  print "#include <Clue/Decay.hh>";
  print "#include <Clue/Cluster.hh>";
}

END {
  print "#endif";
}

/template class .*<.*>;/ {\
  match( $3,".*<.*>" );\
  classname = substr( $3, $3+RSTART, RLENGTH );\
  match( classname, "<.*\*>" );\
  arg = substr( classname, classname+RSTART+1, RLENGTH-3 );
  system( "if test -f $PWD/../include/Clue/" arg ".hh; then echo '#include <Clue/" arg ".hh>'; fi" );

  print "const char* " classname "::SetClassName() {";
  print "  return \"" classname "\";\n}";
}
