#include <iostream>
#include <vector>

#include "GCombiner.hh"
#include "SCombiner.hh"

bool isequal(int a, int b) {
  return a == b;
}

int main(void) {

  typedef vector<int>                       Int_v;
  typedef vector<int>::iterator             Int_it;
  typedef GCombiner<Int_v>                  GC_v;
  typedef GCombiner<Int_v>::iterator        GC_it;
  typedef GC_trait<Int_v>::GCombination     GCombination;
  typedef GC_trait<Int_v>::GCombination_cit GCombination_cit;


  Int_v a(5);
  Int_v b(5);
  Int_v c(2);
  Int_v d(2);

  a[0] = 0;
  a[1] = 1;
  a[2] = 2;
  a[3] = 3;
  a[4] = 4;

  b[0] = 0;
  b[1] = 1;
  b[2] = 2;
  b[3] = 3;
  b[4] = 4;

  c[0] = 20;
  c[1] = 21;

  d[0] = 30;
  d[1] = 31;

  GC_v Comb;
  Comb.push_back(a);
  Comb.push_back(b);
  //  Comb.push_back(c);
  //  Comb.push_back(d);

  cout << " Comb: " << Comb << endl;
  cout << " container a: " << endl;
  copy(a.begin(), a.end(), ostream_iterator<int>(cout, " "));
  cout << endl;

  cout << " container b: " << endl;
  copy(b.begin(), b.end(), ostream_iterator<int>(cout, " "));
  cout << endl;

  cout << " now a combination: " << endl;
  const GC_it end = Comb.end();
  for(GC_it it = Comb.begin(); it != end; ++it) {
    //    cout << " i: " << i++ << endl;
    cout << " it: " << it << endl;
    if(collision(it)) continue;
//      const GCombination v = *it;
//      const GCombination_cit vend = v.end();
//      for(GCombination_cit cit = v.begin(); cit!= vend; ++cit)
//        cout << **cit << " ";
//      cout << endl;
  }

  cout << "-------------------- Unique Iterator -----------" << endl;
  Int_v x(4);
  Int_v y(4);
  Int_v z(4);
  y[0] = x[0] = z[0] = 3;
  y[1] = x[1] = z[1] = 2;
  y[2] = x[2] = z[2] = 1;
  y[3] = x[3] = z[3] = 0;

  GC_v UComb;
  UComb.push_back(x);
  UComb.push_back(y);
  UComb.push_back(z);
  
  const GC_it uend = UComb.end();
  for(GC_it it = UComb.begin(); it != uend; ++it) {
    if(collision(it)) continue;
    cout << " it: siz: " << it.size() 
	 << " [" << *it[0] << "," << *it[1] << "," << *it[2] << "]";
    cout << endl;
    //    cout << " it: " << it << endl;
  }

  
  cout << "-------------------- SCombiner: -----------" << endl;
  Int_v xx(10);
  xx[8] = 15;
  copy(xx.begin(), xx.end(), ostream_iterator<int>(cout," "));
  cout << endl;

  Int_v ab;
  ab.push_back(0);
  ab.push_back(1);
  ab.push_back(2);
  ab.push_back(3);
  //  ab.push_back(4);
  //  ab.push_back(5);

  typedef SCombiner<Int_v,3>                GS_v;
  typedef SCombinerIterator<Int_v,3>        GS_it;

  GS_v SComb(ab);
  const GS_it send = SComb.end();
  cout << "end: " << send << endl;
  //  send.print(cout);
  for(GS_it it = SComb.begin(); it != send; ++it) {
    //    cout << *it[0] << "," << *it[1] << "," << *it[2] << endl;
    //it.print(cout);
    cout << it << endl;
  }
  return 0;
}
