// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   05. Nov 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Point3D interface
//
// changes:
// 05 Nov 2000 (TG) creation
// 20 Nov 2000 (TG) added namespace CLUE
//
// ********************************************************************

#include "geometry/ThreeVector.hh"

#ifdef USE_ROOT
#include <TPolyMarker3D.h>

#ifdef NAMESPACE
namespace CLUE {
#endif

  //==============================================================================
  // Root::Paint
  //==============================================================================
  // How to use: a) create canvas
  //             b) create view via:  TView* view = new TView(1)
  //             c) loop over tracks and call Draw()
  void ThreeVector::Paint(Option_t *option) {
    
    // in a root kumac, gPad->Clear() deletes this pointer.
    TPolyMarker3D* m = new TPolyMarker3D();
    
    m->SetPoint(0, x(), y(), z());
    m->SetMarkerSize(2);
    m->SetMarkerColor(4);
    m->SetMarkerStyle(2);
    
    m->Draw();
  }

  ClassImp(ThreeVector)

#ifdef NAMESPACE
} // namespace CLUE
#endif
#endif
