#ifndef GEOM_INI_HH
#define GEOM_INI_HH
// *****************************************************************************
//
// source:
//
// type:      source code
//
// created:   20. Mai 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Class to initialize the Geometry package
//
// changes:
// 20 Mai 2000 (TG) creation
// 01 Nov 2000 (TG) inherited GeomIni from TObject, full ROOT integration
// 20 Nov 2000 (TG) added namespace CLUE
// 18 Dec 2000 (TG) removed GeomIni class, replaced by global PkgIni object
//
// *****************************************************************************

#ifdef NAMESPACE
namespace CLUE {
#endif

class PkgIni;

/// Global Geom object which holds XCVS information.
extern const PkgIni GeomSteer;

#ifdef NAMESPACE
} // namespace CLUE
#endif
#endif
