// *****************************************************************************
//
// source:
//
// type:      source code
//
// created:   20. Mai 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Class to initialize the Geometry package
//
// changes:
// 20 Mai 2000 (TG) creation
// 01 Nov 2000 (TG) inherited GeomIni from TObject, full ROOT integration
// 20 Nov 2000 (TG) added namespace CLUE
//
// *****************************************************************************
#include <iostream>
#include "geometry/CVStag.Geometry"
#include "geometry/GeomIni.hh"

#ifdef NAMESPACE
namespace CLUE {
#endif

  GeomIni::initializer GeomIni::doIni;

  const char *GeomIni::Version = xcvsVERSION_Geometry;
  const char *GeomIni::Name    = xcvsMODULE_Geometry;
  const char *GeomIni::Date    = xcvsDAYTIME_Geometry;

  //==============================================================================
  // Constructors
  //==============================================================================
  GeomIni::GeomIni() {}


  //==============================================================================
  // Constructor for private class initializer
  //==============================================================================
  GeomIni::initializer::initializer() {
    cout << xcvsMODULE_Geometry 
	 << " version " << xcvsVERSION_Geometry 
	 << " loaded (" << xcvsDAYTIME_Geometry << ")." 
	 << endl;
  }


  //============================================================================
  // GeomIni::print
  //============================================================================
  void GeomIni::print(std::ostream& os) const {
    cout << name()
	 << " version " << version()
	 << " loaded (" << date() << ")."
	 << endl;
  }

#ifdef USE_ROOT
  ClassImp(GeomIni)
#endif
#ifdef NAMESPACE
} // namespace CLUE
#endif
