#ifndef classes_HH
#define classes_HH

#include "GRelationList.hh"

template <class T> class GsPointer;
template <class T> class ClueRelationList;
class Vertex;
class Track;
class Hit;

// ==========================================================================
// Vertex
// ==========================================================================
class Vertex {
public:
  Vertex();
  Vertex(unsigned int n);
  ~Vertex();

//    typedef GRelationIterator<Track>        iterator;
//    typedef ConstGRelationIterator<Track>   const_iterator;
//    typedef ReverseGRelationIterator<Track> reverse_iterator;

  void print(std::ostream& os) const { os << "Vertex [" << i << "]"; }

  GRelationList<Track>& out;
  GRelationList<Track>& in;

  ClueRelationList<Track>& arteout;

  ClueRelationList<Track>& container(const GsPointer<Track>& t) const
    { return arteout; }

  GRelationList<Hit>& ecal;

  GRelationList<Hit>& container(const Hit& t) const { return ecal; }

private:
  unsigned int i;
}; // class Vertex

inline std::ostream& operator<< (std::ostream& os, const Vertex& v) {
  v.print(os);
  return os;
}

// ==========================================================================
// Track
// ==========================================================================
class Track {
public:
  Track();
  Track(unsigned int n);
  ~Track();

  GRelationList<Vertex>& bver;

  GRelationList<Vertex>& container(const Vertex& t) { return bver; }

  void print(std::ostream& os) const { os << "Track [" << i << "]"; }

  inline void set_val(const unsigned int rhs) { i = rhs; }

private:
  unsigned int i;
}; // class Track

inline std::ostream& operator<< (std::ostream& os, const Track& t) {
  t.print(os);
  return os;
}

// ==========================================================================
// Hit
// ==========================================================================
class Hit {
public:
  Hit();
  Hit(unsigned int n);
  ~Hit();

  GRelationList<Vertex>& bver;

  GRelationList<Vertex>& container(const Vertex& t) { return bver; }

  void print(std::ostream& os) const { os << "Hit [" << i << "]"; }

  inline void set_val(const unsigned int rhs) { i = rhs; }

private:
  unsigned int i;
}; // class Hit

inline std::ostream& operator<< (std::ostream& os, const Hit& t) {
  t.print(os);
  return os;
}

#endif
