#include "classes.hh"
#include "GsRelation.hh"

Vertex::Vertex() : 
  out(*new GRelationList<Track>),
  in(*new GRelationList<Track>),
  arteout(*new ClueRelationList<Track>),
  ecal(*new GRelationList<Hit>),
  i(0) {}

Vertex::Vertex(unsigned int n) :
  out(*new GRelationList<Track>),
  in(*new GRelationList<Track>),
  arteout(*new ClueRelationList<Track>),
  ecal(*new GRelationList<Hit>),
  i(n) {}

Vertex::~Vertex() {
  out.unbook_all(*this);
  in.unbook_all(*this);
  ecal.unbook_all(*this);
  // unbooking of arteout is not possible,
  // as no mapping of ArtePointer to memory pointer
  // is available?
  delete &out;
  delete &in;
  delete &arteout;
  delete &ecal;
}

Track::Track() : 
  bver(*new GRelationList<Vertex>),
  i(0) {}

Track::Track(unsigned int n) : 
  bver(*new GRelationList<Vertex>),
  i(n) {}

Track::~Track() {
  for(GRelationIterator<Vertex> it = bver.begin(); it != bver.end(); ++it) {
    it->out.unbook(*this);
    it->in.unbook(*this);
  }

  //  bver.unbook_all(*this);
  delete &bver;
}

Hit::Hit() : 
  bver(*new GRelationList<Vertex>),
  i(0) {}

Hit::Hit(unsigned int n) : 
  bver(*new GRelationList<Vertex>),
  i(n) {}

Hit::~Hit() {
  cout << " remove all relations" <<  endl;
  bver.unbook_all(*this);

  cout << "delete bver: " << endl;
  delete &bver;
}
