#ifndef __EXPRESSIONIF__HH
#define __EXPRESSIONIF__HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   24. Jan 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Interface to Expression Engine
//
// changes:
// 25 Jan 2001 (TG) creation
//
// ********************************************************************
#include <iosfwd>

/** Abstract class which defines the minimal interface to an expression
    engine. This interface decouples GPattern and ClProperty class.
    Whatever expression class is inherited from this interface can be used
    by the GPattern class.
    @author T. Glebe
*/
//==============================================================================
// ToppIf
//==============================================================================
template <class C, class T>
class ExpressionIf {
public:

  /** @name --- Access methods --- */
  /// evaluate expression
  virtual T evaluate( const C& rhs) const = 0;
  ///
  virtual std::ostream& print(std::ostream& os) const = 0;
  /// return a copy of myself
  virtual ExpressionIf<C,T>* propertyClone() const = 0;

}; // end of ExpressionIf

#endif
