#ifndef __SDECAYPATTERNMATCHCONTAINERCC_HH
#define __SDECAYPATTERNMATCHCONTAINERCC_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   02. Mai 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: A DecayPatternMatch container class which also looks for the
//              charge conjugated pattern.
//
// changes:
// 02 Mai 2001 (TG) creation
//
// ********************************************************************

#include "pattern/SDecayPatternMatchContainer.hh"

/** Class which represents a container for DecayPattern matches.

    @memo Generic class
    @author T. Glebe
*/
//==============================================================================
// SDecayPatternMatchContainerCC
//==============================================================================
template <class C, class T, unsigned int NTR>
class SDecayPatternMatchContainerCC : public SDecayPatternMatchContainer<C,T,NTR> {
  typedef list<SPatternMatch<C,T> >                          SPM_l;
  typedef SmartPointer<SDecayPattern<C,T,NTR> >              SDP_sp;

public:
  /** @name --- Constructors --- */
  ///
  SDecayPatternMatchContainerCC();
  ///
  SDecayPatternMatchContainerCC(const SDecayPatternMatchContainer<C,T,NTR>& rhs);
  ///
  virtual ~SDecayPatternMatchContainerCC();

  /** @name --- Access methods --- */
  /// get the charge conjugated decay pattern
  const SDecayPattern<C,T,NTR>& dpatternCC() const;

private:
  /// routine which does the work
  virtual bool do_combine();

  SDP_sp dpatternCC_;       // the charge conjugated decay pattern
};

#include "pattern/SDecayPatternMatchContainerCC.icc"
#endif
